ifeq (distro,$(IMAGE_CLASS))

# Basic applications and User selection lists
# Lists - pkg.in/lists/etersoft/*
# Groups - pkg.in/groups/etersoft/*
mixin/ximper-desktop-base-software:
	@$(call add,THE_LISTS,etersoft/meta/base)
	@$(call add,MAIN_GROUPS,\
	 \
	 etersoft/groups/00_settings\
	 etersoft/base/settings/base\
	 etersoft/base/settings/flatpak\
	 \
	 etersoft/groups/01_accessibility\
	 \
	 etersoft/groups/01_peripheral\
	 etersoft/base/peripheral/asusctl-rog-gui\
	 etersoft/base/peripheral/openrgb\
	 etersoft/base/peripheral/printers\
	 etersoft/base/peripheral/scanners\
	 \
	 etersoft/groups/01_system-management\
	 etersoft/base/system-management/gparted\
	 etersoft/base/system-management/timeshift\
	 \
	 etersoft/groups/02_browsers\
	 etersoft/base/browsers/chromium-gost\
	 etersoft/base/browsers/firefox-esr\
	 etersoft/base/browsers/firefox\
	 etersoft/base/browsers/gnome-web\
	 etersoft/base/browsers/yandex-browser-stable\
	 \
	 etersoft/groups/02_games\
	 etersoft/base/games/lutris\
	 etersoft/base/games/mangohud\
	 etersoft/base/games/portproton\
	 etersoft/base/games/steam\
	 etersoft/base/games/vkbasalt\
	 \
	 etersoft/groups/02_messengers\
	 etersoft/base/messengers/telegram etersoft/base/messengers/whatsapp\
	 \
	 etersoft/groups/03_office\
	 etersoft/base/office/atril\
	 etersoft/base/office/fragments\
	 etersoft/base/office/libreoffice-latest\
	 etersoft/base/office/libreoffice-still\
	 \
	 slinux/multimedia\
	 etersoft/base/multimedia/amberol\
	 etersoft/base/multimedia/cassette\
	 etersoft/base/multimedia/clapper\
	 etersoft/base/multimedia/full-obs-studio\
	 etersoft/base/multimedia/mpv\
	 slinux/multimedia-full-audacity\
	 slinux/multimedia-full-shotcut\
	 \
	 slinux/graphics\
	 etersoft/base/graphics/blender\
	 etersoft/base/graphics/krita\
	 slinux/graphics-full-inkscape\
	 slinux/graphics-full-shotwell\
	 \
	 etersoft/groups/04_dev-tools\
	 etersoft/base/dev-tools/codium\
	 etersoft/base/dev-tools/etersoft-build-utils\
	 etersoft/base/dev-tools/geany\
	 \
	 etersoft/groups/04_virt-machines\
	 etersoft/base/virt-machines/gnome-boxes\
	 etersoft/base/virt-machines/virt-manager\
	 etersoft/base/virt-machines/virtualbox\
	)
	@$(call add,LIVE_LISTS,\
	 etersoft/base/browsers/yandex-browser-stable\
	 etersoft/base/office/libreoffice-still\
	 etersoft/base/office/atril\
	 etersoft/base/messengers/telegram\
	 slinux/graphics-full-shotwell\
	 etersoft/base/system-management/timeshift\
	 etersoft/base/system-management/gparted\
	 slinux/flatpak\
	 )

mixin/ximper-desktop-gnome-software:
	@$(call add,MAIN_GROUPS,\
	 etersoft/gnome/settings/base\
	 etersoft/gnome/accessibility/gnome-a11y\
	 etersoft/gnome/dev-tools/gnome-ssh-agent\
	)
	@$(call add,LIVE_LISTS,etersoft/gnome/settings/base)
	@$(call add,THE_LISTS,etersoft/meta/base-gnome)

mixin/ximper-desktop-hyprland-software:
	@$(call add,MAIN_GROUPS,\
	 etersoft/hyprland/settings/base\
	 etersoft/hyprland/accessibility/hyprmag\
	)
	@$(call add,LIVE_LISTS,etersoft/hyprland/settings/base)
	@$(call add,THE_LISTS,etersoft/meta/base-hyprland)

mixin/ximper-desktop: +alsa +nm-native \
	use/x11/xorg use/xdg-user-dirs use/l10n \
	use/branding/notes
	@$(call set,LOCALES,en_US)
	@$(call add,THE_PACKAGES,pam-limits-desktop beesu polkit dvd+rw-tools fonts-cascadia-code)
	@$(call add,THE_BRANDING,alterator graphics indexhtml backgrounds notes)
	@$(call add,THE_PACKAGES, ximper-repos)
	@$(call add,THE_PACKAGES,$$(THE_IMAGEWRITER))
	@$(call set,THE_IMAGEWRITER,altmediawriter)
	@$(call add,THE_PACKAGES,upower udev-rules-rfkill-uaccess)
	@$(call add,DEFAULT_SERVICES_DISABLE,gssd idmapd krb5kdc rpcbind)
	@$(call add,DEFAULT_SERVICES_ENABLE,cups)
	@$(call add,DEFAULT_SERVICES_ENABLE,alteratord)
	@$(call add,SERVICES_ENABLE,fstrim.timer)
	@$(call add,SERVICES_ENABLE,asusd)
	@$(call add,CONTROL,fusermount:public)
	@$(call add,CONTROL,libnss-role:disabled)
	@$(call add,THE_PACKAGES,sudo)
	@$(call add,CONTROL,sudowheel:enabled)

mixin/ximper-x11: use/luks \
	use/kernel/disable-usb-autosuspend \
	use/branding use/ntp/chrony use/services/lvm2-disable
	@$(call add,THE_LISTS,$(call tags,(base || desktop) && ximper && !extra))
	@$(call add,THE_PACKAGES,disable-usb-autosuspend)
	@$(call add,THE_PACKAGES,btrfs-progs)
	@$(call add,THE_PACKAGES,gpm)
	@$(call add,DEFAULT_SERVICES_DISABLE,gpm powertop)
	@$(call add,LIVE_PACKAGES,volumes-profile-kdesktop)
	@$(call set,INSTALL2_FONTS,fonts-otf-abattis-cantarell)


mixin/ximper-gnome: use/x11/xorg \
	use/x11/gdm \
	+nm-gtk \
	+nm-gtk4 \
	+pipewire
	@$(call add,LIVE_PACKAGES,gnome-flashback)
	@$(call add,THE_PACKAGES,gdm-settings)
	@$(call add,SERVICES_ENABLE,switcheroo-control.service) # Service to check dual-GPU. Q: Maybe to post script if present?
	@$(call add,IM_PACKAGES,imsettings-gsettings)
	@$(call add,THE_PACKAGES,gnome-console)
	@$(call add,PINNED_PACKAGES,gnome-console)

mixin/ximper-wm: use/x11/xorg \
	+nm-gtk
	@$(call add,THE_LISTS,etersoft/meta/base-wm)
	@$(call add,SERVICES_ENABLE,switcheroo-control.service)
	@$(call add,IM_PACKAGES,imsettings-gsettings)
	@$(call add,THE_PACKAGES,xorg-xwayland)
	@$(call add,THE_PACKAGES,kitty)
	@$(call add,PINNED_PACKAGES,kitty)

mixin/ximper-hyprland: use/x11/sddm \
	+pipewire

distro/.ximper-bare: distro/.base \
	use/kernel/laptop use/kernel/net use/kernel/wireless \
	use/docs/license \
	use/stage2/ata use/stage2/fs use/stage2/hid use/stage2/md \
	use/stage2/mmc use/stage2/net use/stage2/net-nfs use/stage2/cifs \
	use/stage2/rtc use/stage2/sbc use/stage2/scsi use/stage2/usb \
	use/stage2/drm use/tty
	@$(call try,SAVE_PROFILE,yes)
	@$(call add,STAGE1_PACKAGES,firmware-linux)
	@$(call add,STAGE1_KMODULES,drm)
ifeq (sisyphus,$(BRANCH))
ifeq (,$(filter-out i586 x86_64,$(ARCH)))
	@$(call set,BOOTLOADER,grubpcboot)
endif
endif

# base target (for most images)
distro/.ximper-minimal-env: distro/.ximper-bare \
	use/isohybrid use/vmguest use/memtest \
	use/efi/dtb +efi; @:


# graphical target (not enforcing xorg drivers or blobs)
distro/.ximper-x11: distro/.ximper-minimal-env mixin/ximper-x11 \
	use/x11/wacom use/x11/amdgpu +wireless \
	use/live/x11 use/live/repo \
	use/live/suspend \
	use/syslinux/ui/gfxboot use/grub/ui/gfxboot
	@$(call add,THE_BRANDING,bootloader)
	@$(call add,THE_LISTS,$(call tags,(base || desktop) && ximper))
	@$(call add,LIVE_LISTS,$(call tags,base rescue))
	@$(call add,LIVE_PACKAGES,gpm)
	@$(call add,DEFAULT_SERVICES_DISABLE,gpm powertop)


distro/.ximper-wm: distro/.ximper-x11 \
	mixin/ximper-desktop +vmguest \
	use/live/rw use/live/ru
	@$(call set,INSTALLER,ximper)

distro/.ximper-install: distro/.ximper-minimal-env +live-installer-pkg \
	use/branding use/bootloader/grub use/luks use/stage2/kms
	@$(call add,LIVE_PACKAGES,fdisk)
ifeq (,$(filter-out i586 x86_64,$(ARCH)))
	@$(call add,LIVE_PACKAGES,xorg-conf-synaptics)
endif
	@$(call add,THE_LISTS,$(call tags,base ximper))
	@$(call add,LIVE_PACKAGES,btrfs-progs)
	@$(call add,THE_BRANDING,alterator)


distro/.ximper-install-x11: distro/.ximper-install +vmguest +wireless \
	mixin/ximper-desktop mixin/ximper-x11 \
	use/branding/complete use/branding/slideshow/once mixin/desktop-installer \
	use/efi/shell use/l10n/default/ru_RU
	@$(call add,LIVE_PACKAGES,installer-feature-fstrim-stage2)
	@$(call add,LIVE_PACKAGES,installer-feature-online-repo)
	@$(call set,INSTALLER,ximper)
	@$(call add,MAIN_PACKAGES,anacron man-whatis usb-modeswitch)

distro/.ximper-install-x11-systemd: distro/.ximper-install-x11 +systemd +systemd-optimal
	@$(call add,THE_PACKAGES,bluez)
	@$(call add,THE_PACKAGES,btrfs-progs)
	@$(call add,DEFAULT_SERVICES_ENABLE,bluetoothd)

distro/.ximper-base: distro/.ximper-install-x11-systemd \
	use/live/rw use/live/ru use/live/x11 use/live/repo \
	use/live/suspend \
	mixin/ximper-desktop-base-software \
	use/fonts/ttf/redhat \
	use/fonts/ttf/google-noto \
	+plymouth;
	@$(call set,META_VOL_ID,Ximper Linux $(DISTRO_VERSION) $(ARCH))
	@$(call set,META_APP_ID,Ximper Linux $(DISTRO_VERSION) $(ARCH) $(shell date +%F))
	@$(call set,BRANDING,etersoft-ximper)
	@$(call set,KFLAVOURS,6.6 6.12)
	@$(call add,MAIN_PACKAGES,kernel-headers-6.12)
	@$(call add,MAIN_PACKAGES,kernel-headers-modules-6.12)
	@$(call add,THE_KMODULES,virtualbox bcmwl)
	@$(call add,THE_PACKAGES,bcmwl-kernel-conf)
	@$(call add,THE_PACKAGES,alterator-notes)
	@$(call add,LIVE_PACKAGES,screenpen)
	@$(call add,FONTS,fonts-ttf-fira-code-nerd)
	@$(call add,DEFAULT_SYSTEMD_USER_SERVICES_ENABLE,ximper-unified-theme-switcher.service)

# nvidia-drm.modeset=1 for Wayland and VR
# Remove nouveau as not needed
# Add install scripts of Nvidia and all releated things out of box
mixin/ximper-nvidia: use/x11/nvidia use/stage2/kms/nvidia
	@$(call add,MAIN_GROUPS,etersoft/base/system-management/nvidia)
	@$(call add,LIVE_PACKAGES,installer-feature-nvidia)
	@$(call add,LIVE_PACKAGES,apt-scripts-nvidia)
	@$(call add,CLEANUP_PACKAGES,'^kernel-modules-drm-nouveau.*')
	@$(call add,BASE_PACKAGES,apt-scripts-nvidia)
	@$(call add,BASE_PACKAGES,nvidia-modprobe nvidia-settings libglut libGLU nvidia-vaapi-driver vulkan-tools \
	nvidia-xconfig libvulkan1 libcuda libcudadebugger libnvcuvid libnvidia-api libnvidia-encode \
	libnvidia-fbc libnvidia-ml libnvidia-ngx libnvidia-nvvm libnvidia-opencl \
	libnvidia-ptxjitcompiler libnvoptix nvidia-smi ocl-nvidia)
	@$(call add,SERVICES_ENABLE,nvidia-suspend.service nvidia-resume.service nvidia-hibernate.service)

mixin/ximper-standard:
	@$(call add,MAIN_GROUPS,\
	 etersoft/base/games/32bit-libs\
	 etersoft/base/system-management/amd\
	)
	@$(call add,LIVE_LISTS,etersoft/base/games/32bit-libs)

distro/ximper-gnome: distro/.ximper-base \
	mixin/ximper-standard \
	mixin/ximper-gnome \
	mixin/ximper-desktop-gnome-software

distro/ximper-gnome-nvidia: distro/.ximper-base \
	mixin/ximper-nvidia \
	mixin/ximper-gnome \
	mixin/ximper-desktop-gnome-software

distro/ximper-hyprland: distro/.ximper-base \
	mixin/ximper-standard \
	mixin/ximper-wm \
	mixin/ximper-hyprland \
	mixin/ximper-desktop-hyprland-software

distro/ximper-hyprland-nvidia: distro/.ximper-base \
	mixin/ximper-nvidia \
	mixin/ximper-wm \
	mixin/ximper-hyprland \
	mixin/ximper-desktop-hyprland-software
endif

# Fonts mixins
use/fonts/ttf/google-noto: use/fonts
	@$(call add,FONTS,fonts-ttf-google-noto-sans)
	@$(call add,FONTS,fonts-ttf-google-noto-serif)
	@$(call add,FONTS,fonts-ttf-google-noto-sans-mono)
	@$(call add,FONTS,fonts-ttf-google-noto-sans-symbols)
	@$(call add,FONTS,fonts-ttf-google-noto-sans-symbols2)
	@$(call add,FONTS,fonts-ttf-google-noto-emoji)
	@$(call add,FONTS,fonts-ttf-google-noto-emoji-color)
	@$(call add,FONTS,fonts-otf-google-noto-cjk)
